> ## Documentation Index
> Fetch the complete documentation index at: https://docs.authsignal.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Query Users

> Query users by a set of filters.



## OpenAPI

````yaml server-api GET /users
openapi: 3.0.0
info:
  description: Authsignal's Server API.
  version: 1.0.0
  title: Server API
  termsOfService: https://www.authsignal.com/legal/terms-of-service
  contact:
    email: hello@authsignal.com
servers:
  - url: https://api.authsignal.com/v1
  - url: https://au.api.authsignal.com/v1
  - url: https://eu.api.authsignal.com/v1
  - url: https://ca.api.authsignal.com/v1
security:
  - basicAuth: []
tags:
  - name: users
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: challenge
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: authenticator configurations
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: actions
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: query
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: email
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: sms
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: verify
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: challenges
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: sessions
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: devices
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
externalDocs:
  description: Find out more about Authsignal
  url: https://docs.authsignal.com
paths:
  /users:
    get:
      tags:
        - users
        - query
      summary: Query users
      description: Query users by a set of filters.
      operationId: queryUsers
      parameters:
        - in: query
          name: username
          schema:
            type: string
            description: Filter users by username.
        - in: query
          name: email
          schema:
            type: string
            description: Filter users by email address.
        - in: query
          name: phoneNumber
          schema:
            type: string
            description: Filter users by phone number in E.164 format.
        - in: query
          name: token
          schema:
            type: string
            description: Filter users by token.
        - in: query
          name: limit
          schema:
            type: integer
            description: The maximum number of users to return.
        - in: query
          name: lastEvaluatedUserId
          schema:
            type: string
            description: >-
              The user ID to start the query from. Use this for pagination by
              passing the `lastEvaluatedUserId` from the previous response.
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/QueryUsersResponse'
        '401':
          $ref: '#/components/responses/Unauthorized'
components:
  schemas:
    QueryUsersResponse:
      type: object
      properties:
        users:
          type: array
          items:
            $ref: '#/components/schemas/QueryUsersResponseUser'
          description: The list of users matching the query.
        lastEvaluatedUserId:
          type: string
          description: >-
            The user ID to use as the starting point for the next page of
            results. If not present, there are no more results.
    QueryUsersResponseUser:
      type: object
      properties:
        userId:
          type: string
          description: The user's ID.
        email:
          type: string
          description: The user's email address.
        phoneNumber:
          type: string
          description: The user's phone number in E.164 format.
        username:
          type: string
          description: >-
            The username used as the primary identifier for passkeys, e.g. an
            email address.
        displayName:
          type: string
          description: >-
            The display name used as an optional secondary identifier for
            passkeys, e.g. the user's full name.
        isEnrolled:
          type: boolean
          description: >-
            True if the user is enrolled with at least one verification method
            and can be challenged.
        enrolledVerificationMethods:
          type: array
          items:
            $ref: '#/components/schemas/VerificationMethod'
          description: The list of verification methods which the user has enrolled.
        createdAt:
          type: string
          format: date-time
          description: The time when the user was created.
      required:
        - userId
    Error:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
      required:
        - error
    VerificationMethod:
      type: string
      enum:
        - SMS
        - AUTHENTICATOR_APP
        - EMAIL_MAGIC_LINK
        - EMAIL_OTP
        - PUSH
        - DEVICE
        - SECURITY_KEY
        - PASSKEY
        - VERIFF
        - IPROOV
        - PALM_BIOMETRICS_RR
        - IDVERSE
  responses:
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic
      description: >-
        Use your Authsignal Server API secret key as the username and leave the
        password empty. The secret key can be found in the API Keys section of
        the Authsignal Portal settings page.

````